=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2009-04-29 07:16:04 +0000
+++ drizzled/field.cc	2009-05-04 23:54:28 +0000
@@ -823,8 +823,7 @@
    key_start(0), part_of_key(0), part_of_key_not_clustered(0),
    part_of_sortkey(0), unireg_check(unireg_check_arg),
    field_length(length_arg), null_bit(null_bit_arg),
-   is_created_from_null_item(false),
-   is_stored(true)
+   is_created_from_null_item(false)
 {
   flags=null_ptr ? 0: NOT_NULL_FLAG;
   comment.str= (char*) "";
@@ -1318,7 +1317,6 @@
               ((decimals_arg & FIELDFLAG_MAX_DEC) << FIELDFLAG_DEC_SHIFT) |
               (maybe_null ? FIELDFLAG_MAYBE_NULL : 0) |
               (is_unsigned ? 0 : FIELDFLAG_DECIMAL));
-  is_stored= true;
 }
 
 
@@ -1381,7 +1379,6 @@
   interval_list.empty();
 
   comment= *fld_comment;
-  is_stored= true;
 
   /*
     Set NO_DEFAULT_VALUE_FLAG if this field doesn't have a default value and
@@ -1741,7 +1738,6 @@
   charset=    old_field->charset();		// May be NULL ptr
   comment=    old_field->comment;
   decimals=   old_field->decimals();
-  is_stored= old_field->is_stored;
 
   /* Fix if the original table had 4 byte pointer blobs */
   if (flags & BLOB_FLAG)
@@ -1933,3 +1929,14 @@
   }
 }
 
+bool Field::isRead() 
+{ 
+  return table->read_set->test(field_index); 
+}
+
+
+bool Field::isWrite()
+{ 
+  return table->write_set->test(field_index); 
+}
+

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2009-04-29 07:16:04 +0000
+++ drizzled/field.h	2009-05-04 23:54:28 +0000
@@ -112,13 +112,6 @@
    */
   bool is_created_from_null_item;
 
-  /*
-    Indication that the field is physically stored in tables
-    rather than just generated on SQL queries.
-    As of now, false can only be set for generated-only virtual columns.
-  */
-  bool is_stored;
-
   Field(unsigned char *ptr_arg,uint32_t length_arg,unsigned char *null_ptr_arg,
         unsigned char null_bit_arg, utype unireg_check_arg,
         const char *field_name_arg);
@@ -526,6 +519,9 @@
   friend class Item_sum_max;
   friend class Item_func_group_concat;
 
+  bool isRead();
+  bool isWrite();
+
 private:
   /*
     Primitive for implementing last_null_byte().
@@ -580,8 +576,6 @@
   uint32_t  decimals, flags, pack_length, key_length;
   Field::utype unireg_check;
   TYPELIB *interval;			// Which interval to use
-  TYPELIB *save_interval;               // Temporary copy for the above
-                                        // Used only for UCS2 intervals
   List<String> interval_list;
   const CHARSET_INFO *charset;
   Field *field;				// For alter table
@@ -589,13 +583,6 @@
   uint8_t       interval_id;	// For rea_create_table
   uint32_t	offset,pack_flag;
 
-  /*
-    Indication that the field is phycically stored in tables
-    rather than just generated on SQL queries.
-    As of now, FALSE can only be set for generated-only virtual columns.
-  */
-  bool is_stored;
-
   Create_field() :after(0) {}
   Create_field(Field *field, Field *orig_field);
   /* Used to make a clone of this object for ALTER/CREATE TABLE */

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-04-29 07:16:04 +0000
+++ drizzled/handler.cc	2009-05-04 21:06:03 +0000
@@ -1496,24 +1496,6 @@
 
 
 /**
-  MySQL signal that it changed the column bitmap
-
-  This is for handlers that needs to setup their own column bitmaps.
-  Normally the handler should set up their own column bitmaps in
-  index_init() or rnd_init() and in any column_bitmaps_signal() call after
-  this.
-
-  The handler is allowed to do changes to the bitmap after a index_init or
-  rnd_init() call is made as after this, MySQL will not use the bitmap
-  for any program logic checking.
-*/
-void handler::column_bitmaps_signal()
-{
-  return;
-}
-
-
-/**
   Reserves an interval of auto_increment values from the handler.
 
   offset and increment means that we want values to be of the form
@@ -1540,7 +1522,6 @@
   (void) extra(HA_EXTRA_KEYREAD);
   table->mark_columns_used_by_index_no_reset(table->s->next_number_index,
                                         table->read_set);
-  column_bitmaps_signal();
   index_init(table->s->next_number_index, 1);
   if (table->s->next_number_keypart == 0)
   {						// Autoincrement at key-start

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2009-04-29 07:16:04 +0000
+++ drizzled/handler.h	2009-05-04 21:06:03 +0000
@@ -374,14 +374,6 @@
   { assert(0); return "";}
 
 
-  /**
-    Signal that the table->read_set and table->write_set table maps changed
-    The handler is allowed to set additional bits in the above map in this
-    call. Normally the handler should ignore all calls until we have done
-    a ha_rnd_init() or ha_index_init(), write_row(), update_row or delete_row()
-    as there may be several calls to this routine.
-  */
-  virtual void column_bitmaps_signal();
   uint32_t get_index(void) const { return active_index; }
   virtual int close(void)=0;
 

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-04-29 07:16:04 +0000
+++ drizzled/sql_base.cc	2009-05-04 18:52:14 +0000
@@ -883,7 +883,7 @@
 {
   for (Table *table= session->temporary_tables ; table ; table= table->next)
   {
-    if ((table->query_id == session->query_id) && ! table->open_by_handler)
+    if ((table->query_id == session->query_id))
     {
       table->query_id= 0;
       table->file->ha_reset();

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-04-29 07:16:04 +0000
+++ drizzled/sql_table.cc	2009-05-04 21:54:14 +0000
@@ -1127,7 +1127,6 @@
             null_fields--;
 	  sql_field->flags=		dup_field->flags;
           sql_field->interval=          dup_field->interval;
-          sql_field->is_stored=      dup_field->is_stored;
 	  it2.remove();			// Remove first (create) definition
 	  select_field_pos--;
 	  break;
@@ -1159,23 +1158,6 @@
     sql_field->offset= record_offset;
     if (MTYP_TYPENR(sql_field->unireg_check) == Field::NEXT_NUMBER)
       auto_increment++;
-    /*
-          For now skip fields that are not physically stored in the database
-          (virtual fields) and update their offset later
-          (see the next loop).
-        */
-    if (sql_field->is_stored)
-      record_offset+= sql_field->pack_length;
-  }
-  /* Update virtual fields' offset */
-  it.rewind();
-  while ((sql_field=it++))
-  {
-    if (not sql_field->is_stored)
-    {
-      sql_field->offset= record_offset;
-      record_offset+= sql_field->pack_length;
-    }
   }
   if (timestamps_with_niladic > 1)
   {
@@ -1413,12 +1395,6 @@
 	    return(true);
 	  }
 	}
-        if (not sql_field->is_stored)
-        {
-          /* Key fields must always be physically stored. */
-          my_error(ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN, MYF(0));
-          return(true);
-        }
 	if (!(sql_field->flags & NOT_NULL_FLAG))
 	{
 	  if (key->type == Key::PRIMARY)
@@ -3995,13 +3971,6 @@
     if (def)
     {						// Field is changed
       def->field=field;
-      if (field->is_stored != def->is_stored)
-      {
-        my_error(ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
-                 MYF(0),
-                 "Changing the STORED status");
-        goto err;
-      }
       if (!def->after)
       {
 	new_create_list.push_back(def);

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2009-04-26 16:18:49 +0000
+++ drizzled/sql_update.cc	2009-05-04 21:06:03 +0000
@@ -121,8 +121,6 @@
   table->file->position(table->record[0]);
   /* Add all fields used by unique index to read_set. */
   *(table->read_set) |= unique_map;
-  /* Tell the engine about the new set. */
-  table->file->column_bitmaps_signal();
   /* Read record that is identified by table->file->ref. */
   (void) table->file->rnd_pos(table->record[1], table->file->ref);
   /* Copy the newly read columns into the new record. */

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-04-29 07:16:04 +0000
+++ drizzled/table.cc	2009-05-04 22:41:24 +0000
@@ -556,7 +556,6 @@
 
   share->fields= table.field_size();
   share->vfields= 0;
-  share->stored_fields= share->fields;
 
   share->field= (Field**) alloc_root(&share->mem_root,
 				     ((share->fields+1) * sizeof(Field*)));
@@ -856,8 +855,6 @@
     }
 
     enum_field_types field_type;
-    bool field_is_stored= true;
-
 
     field_type= proto_field_type_to_drizzle_type(pfield.type());
 
@@ -966,7 +963,6 @@
 
     f->field_index= fieldnr;
     f->comment= comment;
-    f->is_stored= field_is_stored;
     if(!default_value
        && !(f->unireg_check==Field::NEXT_NUMBER)
        && (f->flags & NOT_NULL_FLAG)
@@ -982,11 +978,6 @@
     if (use_hash) /* supposedly this never fails... but comments lie */
       (void) my_hash_insert(&share->name_hash,
 			    (unsigned char*)&(share->field[fieldnr]));
-
-    if(!f->is_stored)
-    {
-      share->stored_fields--;
-    }
   }
 
   keyinfo= share->key_info;
@@ -1537,7 +1528,6 @@
   memset(bitmaps, 0, bitmap_size*3);
 #endif
 
-  outparam->no_replicate= outparam->file;
   session->status_var.opened_tables++;
 
   return (0);
@@ -2639,13 +2629,10 @@
 
 void Table::prepare_for_position()
 {
-
   if ((file->ha_table_flags() & HA_PRIMARY_KEY_IN_READ_INDEX) &&
       s->primary_key < MAX_KEY)
   {
     mark_columns_used_by_index_no_reset(s->primary_key, read_set);
-    /* signal change */
-    file->column_bitmaps_signal();
   }
   return;
 }
@@ -2690,8 +2677,6 @@
   key_read= 0;
   (void) file->extra(HA_EXTRA_NO_KEYREAD);
   default_column_bitmaps();
-  file->column_bitmaps_signal();
-  return;
 }
 
 
@@ -2729,7 +2714,6 @@
   write_set->set(found_next_number_field->field_index);
   if (s->next_number_keypart)
     mark_columns_used_by_index_no_reset(s->next_number_index, read_set);
-  file->column_bitmaps_signal();
 }
 
 
@@ -2761,7 +2745,6 @@
       if ((*reg_field)->flags & PART_KEY_FLAG)
         read_set->set((*reg_field)->field_index);
     }
-    file->column_bitmaps_signal();
   }
 
   {
@@ -2774,10 +2757,7 @@
     if (s->primary_key == MAX_KEY)
       file->use_hidden_primary_key();
     else
-    {
       mark_columns_used_by_index_no_reset(s->primary_key, read_set);
-      file->column_bitmaps_signal();
-    }
   }
 }
 
@@ -2812,7 +2792,6 @@
       if (is_overlapping(merge_keys, (*reg_field)->part_of_key))
         read_set->set((*reg_field)->field_index);
     }
-    file->column_bitmaps_signal();
   }
 
   {
@@ -2825,10 +2804,7 @@
     if (s->primary_key == MAX_KEY)
       file->use_hidden_primary_key();
     else
-    {
       mark_columns_used_by_index_no_reset(s->primary_key, read_set);
-      file->column_bitmaps_signal();
-    }
   }
   return;
 }

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-04-29 07:16:04 +0000
+++ drizzled/table.h	2009-05-04 21:06:03 +0000
@@ -267,11 +267,9 @@
   */
   bool open_placeholder;
   bool locked_by_logger;
-  bool no_replicate;
   bool locked_by_name;
   bool no_cache;
-  /* To signal that the table is associated with a HANDLER statement */
-  bool open_by_handler;
+
   /*
     To indicate that a non-null value of the auto_increment field
     was provided by the user or retrieved from the current record.
@@ -302,8 +300,6 @@
   {
     read_set= read_set_arg;
     write_set= write_set_arg;
-    if (file)
-      file->column_bitmaps_signal();
   }
   inline void column_bitmaps_set_no_signal(std::bitset<MAX_FIELDS> *read_set_arg,
                                            std::bitset<MAX_FIELDS> *write_set_arg)

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2009-04-29 01:24:32 +0000
+++ drizzled/table_share.h	2009-05-04 22:41:24 +0000
@@ -106,8 +106,6 @@
   uint32_t null_bytes;
   uint32_t last_null_bit_pos;
   uint32_t fields;				/* Number of fields */
-  uint32_t stored_fields;                   /* Number of stored fields
-                                           (i.e. without generated-only ones) */
   uint32_t rec_buff_length;                 /* Size of table->record[] buffer */
   uint32_t keys, key_parts;
   uint32_t max_key_length, max_unique_length, total_key_length;

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2009-04-29 07:16:04 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2009-05-04 23:54:28 +0000
@@ -3631,7 +3631,7 @@
 	}
 
 	n_fields = (ulint)table->s->fields; /* number of columns */
-	n_stored_fields= (ulint)table->s->stored_fields; /* number of stored columns */
+	n_stored_fields= (ulint)table->s->fields; /* number of stored columns */
 
 	if (!prebuilt->mysql_template) {
 		prebuilt->mysql_template = (mysql_row_templ_t*)
@@ -3663,8 +3663,6 @@
 	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
 		templ = prebuilt->mysql_template + n_requested_fields;
 		field = table->field[sql_idx];
-		if (!field->is_stored)
-		       goto skip_field;
 
 		if (UNIV_LIKELY(templ_type == ROW_MYSQL_REC_FIELDS)) {
 			/* Decide which columns we should fetch
@@ -3688,12 +3686,12 @@
 				goto include_field;
 			}
 
-                        if (table->read_set->test(sql_idx) ||
-                            table->write_set->test(sql_idx)) {
+                        if (field->isRead() || field->isWrite())
 				/* This field is needed in the query */
-
 				goto include_field;
-			}
+
+                        assert(table->read_set->test(sql_idx) == field->isRead());
+                        assert(table->write_set->test(sql_idx) == field->isWrite());
 
 			if (fetch_primary_key_cols
 				&& dict_table_col_in_clustered_key(
@@ -3766,10 +3764,7 @@
 			prebuilt->templ_contains_blob = TRUE;
 		}
 skip_field:
-                if (field->is_stored)
-                {
-                  innodb_idx++;
-                }
+                innodb_idx++;
 		if (need_second_pass && (sql_idx+1 == n_fields))
 		{
                   prebuilt->n_index_fields= n_requested_fields;
@@ -4258,8 +4253,6 @@
 
 	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
 		field = table->field[sql_idx];
-		if (!field->is_stored)
-		  continue;
 
 		o_ptr = (const byte*) old_row + get_field_offset(table, field);
 		n_ptr = (const byte*) new_row + get_field_offset(table, field);
@@ -4354,8 +4347,7 @@
 				&prebuilt->table->cols[innodb_idx], clust_index);
 			n_changed++;
 		}
-		if (field->is_stored)
-		  innodb_idx++;
+                innodb_idx++;
 	}
 
 	uvect->n_fields = n_changed;
@@ -5338,7 +5330,7 @@
 	/* We pass 0 as the space id, and determine at a lower level the space
 	id where to store the table */
 
-	table = dict_mem_table_create(table_name, 0, form->s->stored_fields, flags);
+	table = dict_mem_table_create(table_name, 0, form->s->fields, flags);
 
 	if (path_of_temp_table) {
 		table->dir_path_of_temp_table =
@@ -5347,8 +5339,6 @@
 
 	for (i = 0; i < n_cols; i++) {
 		field = form->field[i];
-		if (!field->is_stored)
-		  continue;
 
 		col_type = get_innobase_type_from_mysql_type(&unsigned_type,
 									field);

